﻿Imports System.IO
Public Class MisImpreciones
    Friend NombreArchivoParaImpresora As String
    Private MiPrintPreviewDialog As New PrintPreviewDialog
    Private MiPrintDialog As New PrintDialog
    Private WithEvents MiPrintDocument As New System.Drawing.Printing.PrintDocument
    Private MiDoc As StreamReader

    Private Sub MiPrintDocument_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles MiPrintDocument.PrintPage
        Dim Ligne As String
        Dim Position As System.Drawing.PointF
        Dim Rectangle As RectangleF
        Dim Police As Font = Nothing
        Dim HauteurLigne As Single
        '     Dim NbrLignesParPage As Integer   ' No necesario para imprimar ticket que es continuo
        Dim NumLigne As Integer = 0

        Dim SignoEgual As Integer = 0  ' las lineas ==== mostran los diferentes contenidos

        Do Until MiDoc.Peek = -1               ' Leer el archivo linea por linea 

            Ligne = MiDoc.ReadLine()   ' Leer una linea 
            If Ligne.Substring(0, 1) = "=" Then  ' Linea ===============
                SignoEgual += 1
                e.Graphics.DrawLine(Pens.Black, e.MarginBounds.Left, e.MarginBounds.Top + (NumLigne * HauteurLigne), e.MarginBounds.Right, e.MarginBounds.Top + (NumLigne * HauteurLigne))
            Else   ' Aqui son los diferentes formatos segun el contenido
                If NumLigne = 0 Then   ' Header
                    Police = New Font("Times New Roman", 16, FontStyle.Bold)  ' Ajustar formato
                    ' Este es posible calcular longitud de la frase et centrar segun el ancho de a imprimar
                End If
                If SignoEgual = 0 Then  ' Fecha y numero
                    Police = New Font("Courier New", 12, FontStyle.Regular)  ' Ajustar formato
                End If
                If SignoEgual = 1 Then  ' Detalle
                    Police = New Font("Courier New", 10, FontStyle.Regular)  ' Ajustar formato
                End If
                If SignoEgual = 2 Then  ' Total
                    Police = New Font("Courier New", 12, FontStyle.Regular)  ' Ajustar formato
                End If
                If SignoEgual = 3 Then  ' Footer
                    Police = New Font("Courier New", 12, FontStyle.Bold)  ' Ajustar formato
                End If

                HauteurLigne = Police.GetHeight(e.Graphics)
                Position = New PointF(e.MarginBounds.Left, e.MarginBounds.Top + (NumLigne * HauteurLigne))
                Rectangle.Location = Position           ' taille
                e.Graphics.DrawString(Ligne, Police, Brushes.Black, Rectangle)

            End If

            NumLigne += 1

        Loop

        If MiDoc.Peek <> -1 Then
            e.HasMorePages = True
        Else
            MiDoc.Close()
            MiDoc = New StreamReader(NombreArchivoParaImpresora)   ' En prévisualisation, cette procédure 
        End If
    End Sub

    Private Sub MisImpreciones_Closed(sender As Object, e As EventArgs) Handles Me.Closed
        MiPrintDialog.Dispose()
        MiPrintPreviewDialog.Dispose()
    End Sub

    Private Sub MisImpreciones_Load(sender As Object, e As EventArgs) Handles Me.Load
        If NombreArchivoParaImpresora = String.Empty OrElse Not File.Exists(NombreArchivoParaImpresora) Then
            Me.Close()
        End If
        Dim Resultado As DialogResult
        MiPrintDialog.Document = MiPrintDocument  ' Elimimar 3 lineas si no seleccion del la impresora
        Resultado = MiPrintDialog.ShowDialog()
        If Resultado = Windows.Forms.DialogResult.OK Then
            MiPrintPreviewDialog.Document = MiPrintDocument
            MiPrintDocument.DocumentName = NombreArchivoParaImpresora
            MiDoc = New StreamReader(MiPrintDocument.DocumentName)
            MiPrintPreviewDialog.Dock = DockStyle.Fill
            Resultado = MiPrintPreviewDialog.ShowDialog()
            If Resultado = Windows.Forms.DialogResult.OK Then
                MiDoc.Close()
                MiDoc.Dispose()
            Else
                Me.Close()
            End If
        End If
    End Sub
End Class


